package cn.net.cpzslibs.prot.handset.jinLiquor;

import com.google.gson.Gson;

import java.io.DataInputStream;
import java.io.DataOutputStream;
import java.io.IOException;
import java.net.Socket;
import java.util.ArrayList;
import java.util.List;

import cn.net.cpzslibs.prot.ProtBase;
import cn.net.cpzslibs.prot.SocketCreate;
import cn.net.cpzslibs.prot.handset.bean.req.jinLiquor.Jin20030ReqBean;
import cn.net.cpzslibs.prot.handset.bean.res.jinLiquor.Jin20030ResBean;
import cn.net.cpzslibs.prot.handset.bean.res.jinLiquor.WarehouseOrderBean;
import cn.net.cpzslibs.prot.utils.StrUtils;


public class Jin20030CombineWarehouseOrder extends ProtBase {
	
	private final short iTaskCode20030 = 20030;
	private Gson gson;
	private Jin20030ResBean resBean;
	private String orderNo;
	private List<WarehouseOrderBean> orders = new ArrayList<>();
	private boolean isEnd = false;//true：所有协议包已经请求完      false：服务器返回的数据还未接收完全
	
	public Jin20030CombineWarehouseOrder() {
//		this.sInspectorId = sInspectorId;
		gson = new Gson();
	}
	
	public Jin20030ResBean getResBean(){
		return this.resBean;
	}
	
	public void combineOrder(SocketCreate create, Jin20030ReqBean reqBean) throws IOException {
		orderNo = reqBean.getOrderNo();
		recProt(create.getSocket(), create.getDos(), create.getDis(),reqBean);
	}
	
	private void recProt(Socket socket, DataOutputStream dos,
			DataInputStream dis,Jin20030ReqBean reqBean)
			throws IOException {
		if (socket.isConnected()) {
			if (!socket.isOutputShutdown()) {
				//发送登录信息
				debugLog(iTaskCode20030, "开始请求信息");
				sendProt(dos, reqBean);
			}
		}
		if (socket.isConnected()) {
			if (!socket.isInputShutdown()) {
				while (!isEnd) {
					//服务器可能分多次包返回数据
					recLoginDis(dis);
				}
			}
		}
	}
	
	static int cTest = 0;
	
	/**
	 * 读取JSon数据
	 * 
	 * @param dis
	 * @throws IOException
	 */
	private void recLoginDis(DataInputStream dis) throws IOException {
		debugLog(iTaskCode20030, (cTest++) + "获取接收的数据");
		recHeader(dis);
		int jsonLength = getiRecBodySize() - 2;
		String jsonData = getUTF8(dis, jsonLength);
		debugLog(iTaskCode20030, jsonData);
		if (!StrUtils.isEmpty(jsonData)) {
			resBean = gson.fromJson(jsonData, Jin20030ResBean.class);
			
			if (resBean.getList() != null) {
				orders.addAll(resBean.getList());
			}
			if (resBean.getIndex() == 0) {
				//所有协议包已经请求完
				resBean.setList(orders);
				isEnd = true;
			}
			if (resBean.getResult() == 1) {
				//请求时遇到错误信息
				isEnd = true;
			}
		} else {
			isEnd = true;
		}

		recCheckCode(dis);
		
	}
	
	
	/**
	 * 发送JSon数据到服务器
	 * @param dos
	 * @param iUserType
	 * @param loginBean
	 * @throws IOException
	 */
	private void sendProt(DataOutputStream dos,Jin20030ReqBean reqBean) throws IOException {
		String bodyContent = gson.toJson(reqBean);
		short bodySize = countBodySize(bodyContent);
		sendHeader(dos, iTaskCode20030, bodySize);// 84
		dos.write(bodyContent.getBytes("UTF-8"));
//		sendCheckCode(dos);
		sendCheckCoded(dos,bodyContent.getBytes("UTF-8"));
	}
	

}
